/*
1010
Version 1.0
Copyright (c) 2017 Dryane_
1010 is released under the MIT License
http://www.danieljosephryan.com/
*/
var binaryClip = function(options){
 
    var root = this;
    
    root.vars = {
        el  : null,
        speed  : 128
    };
 
    root.construct = function(options){
        jQuery.extend(root.vars , options);
    };
 
    root.animateBinary = function(){
        startAnimation();
    };
    root.instantBinary = function(){
        binaryNow();
    };
    root.removeBinary = function(){
        removeAnimation();
    };
    root.instantRemove = function(){
        removeNow();
    };
 
 	var applyCSS = function() {
 		if( jQuery(root.vars.el).css('font-family').toLowerCase() != 'courier') {
			jQuery(root.vars.el).css("font-family", "Courier");
		}
 		if( jQuery(root.vars.el).css('word-wrap').toLowerCase() != 'break-word') {
			jQuery(root.vars.el).css("word-wrap", "break-word");
		}
 		if( jQuery(root.vars.el).css('-webkit-background-clip').toLowerCase() != 'text') {
			jQuery(root.vars.el).css("-webkit-background-clip", "text");
		}
 		if( jQuery(root.vars.el).css('-webkit-text-fill-color').toLowerCase() != 'transparent') {
			jQuery(root.vars.el).css("-webkit-text-fill-color", 'transparent');
		}
 	}

 	var numberOfLetters = function() {
		var fontSize = jQuery(root.vars.el).css("font-size");
		fontSize = fontSize.replace(/\D/g,'');
		var fontHeight = fontSize * 1.2;
		var fontWidth = fontHeight / 2;
		var fontArea = fontHeight * fontWidth;

		var containerHeight = jQuery(root.vars.el).innerHeight();
		var containerWidth = jQuery(root.vars.el).innerWidth();
		var containArea = containerHeight * containerWidth;

		var numberOfLetters = containArea / fontArea;

		return numberOfLetters;
 	}

    var startAnimation = function() {
        var stop = 0;

        numberOfLetters = numLetters;

		var int = setInterval(function(){ 
			for (var i = 0; i < root.vars.speed; i++) {
				jQuery(root.vars.el).prepend(Math.round(Math.random()));
			}
			stop++;
			if (stop > (numberOfLetters / root.vars.speed)) {
				clearInterval(int);
			}
		}, 1);
    };

    var binaryNow = function() {
        numberOfLetters = numLetters;
		for (var i = 0; i < numberOfLetters; i++) {
			jQuery(root.vars.el).prepend(Math.round(Math.random()));
		}
    };


    var removeNow = function() {
		jQuery(root.vars.el).text("");
    };

    var removeAnimation = function() {
        var stop = 0;

        numberOfLetters = numLetters;

		var int = setInterval(function(){ 
			for (var i = 0; i < root.vars.speed; i++) {
				jQuery(root.vars.el).prepend('&nbsp;');
			}
			stop++;
			if (stop > (numberOfLetters / root.vars.speed)) {
				clearInterval(int);
				removeNow();
			}
		}, 1);
    }

    root.construct(options);
 	var numLetters = numberOfLetters();

 	applyCSS();
 
};